Package org.apache.sysds.runtime.frame.data.columns

## Class ABooleanArray

- java.lang.Object
- - org.apache.sysds.runtime.frame.data.columns.Array<Boolean>
  - - org.apache.sysds.runtime.frame.data.columns.ABooleanArray

All Implemented Interfaces:
  `org.apache.hadoop.io.Writable`

Direct Known Subclasses:
  `BitSetArray`, `BooleanArray`

    public abstract class ABooleanArray
    extends Array<Boolean>

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.sysds.runtime.frame.data.columns.Array

`Array.ArrayIterator`

### Constructor Summary

Constructors
`ABooleanArray​(int size)`

### Method Summary

All Methods Instance Methods Abstract Methods
`abstract ABooleanArray` `clone()` Overwrite of the java internal clone function for arrays, return a clone of underlying data that is mutable, (not immutable data.) Immutable data is dependent on the individual allocated arrays
`abstract boolean` `isAllTrue()`
`abstract ABooleanArray` `select​(boolean[] select, int nTrue)` Slice out the true indices in the select input and return the sub array.
`abstract ABooleanArray` `select​(int[] indices)` Slice out the specified indices and return the sub array.
`abstract ABooleanArray` `slice​(int rl, int ru)` Slice out the sub range and return new array with the specified type.

### Methods inherited from class org.apache.sysds.runtime.frame.data.columns.Array

`analyzeValueType, append, append, append, baseMemoryCost, changeType, changeTypeWithNulls, containsNull, fill, fill, findEmpty, findEmptyInverse, get, get, getAsByteArray, getAsDouble, getAsNaNDouble, getCache, getExactSerializedSize, getFrameArrayType, getInMemorySize, getIterator, getMinMaxLength, getNulls, getRecodeMap, getValueType, isEmpty, isNotEmpty, isShallowSerialize, reset, set, set, set, set, set, setCache, setFromOtherType, setFromOtherTypeNz, setFromOtherTypeNz, setNz, setNz, size, toString`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.hadoop.io.Writable

`readFields, write`

### Constructor Detail

#### ABooleanArray

    public ABooleanArray​(int size)

### Method Detail

#### isAllTrue

    public abstract boolean isAllTrue()

#### slice

    public abstract ABooleanArray slice​(int rl,
                                        int ru)

Description copied from class: `Array`
Slice out the sub range and return new array with the specified type. If the conversion fails fallback to normal slice.

Specified by:
  `slice` in class `Array<Boolean>`
Parameters:
  `rl` - row start
  `ru` - row end (not included)
Returns:
  A new array of sub range.

#### clone

    public abstract ABooleanArray clone()

Description copied from class: `Array`
Overwrite of the java internal clone function for arrays, return a clone of underlying data that is mutable, (not immutable data.) Immutable data is dependent on the individual allocated arrays

Specified by:
  `clone` in class `Array<Boolean>`
Returns:
  A clone

#### select

    public abstract ABooleanArray select​(int[] indices)

Description copied from class: `Array`
Slice out the specified indices and return the sub array.

Specified by:
  `select` in class `Array<Boolean>`
Parameters:
  `indices` - The indices to slice out
Returns:
  the sliced out indices in an array format

#### select

    public abstract ABooleanArray select​(boolean[] select,
                                         int nTrue)

Description copied from class: `Array`
Slice out the true indices in the select input and return the sub array.

Specified by:
  `select` in class `Array<Boolean>`
Parameters:
  `select` - a boolean vector specifying what to select
  `nTrue` - number of true values inside select
Returns:
  the sliced out indices in an array format